      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) TGTRLS(V5R3M0)
      *=============================================================================================
      * Module.....: XVERRH_M03
      * By.........: Alan Campin
      * Date.......: 08/26/2008
      * Purpose....: Error Handling Functions. This module contains
      *                ILE Condition Handling functions.
      *---------------------------------------------------------------------------------------------
      * Program Modification Section:
      *------------------------------
      * By.........:
      * Date.......:
      * Description:
      *            :
      *=============================================================================================
     h nomain

      /copy *libl/qsrcf,cb_StdTypx
      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,xverrh_pr

     d INT_BuildConditionToken...
     d                 pr                  Like(StdLgl)
     d   PR_InMessageId...
     d                                     Like(StdMsgId)
     d                                     Value
     d   PR_InSeverity...
     d                                     Like(StdIntSml)
     d                                     Value
     d   PR_InConditionType...
     d                                     Like(StdChr)
     d                                     Value
     d   PR_OutConditionToken...
     d                                     Like(StdCndTok)
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * ERRH_BuildConditionToken
     *   This function builds a ILE Condition Token.
     *
     *   Note: CPF9899 is used as a general purpose message to signal
     *           error. This done because CEESGL takes the facility id
     *           and appends it to create a message file name as
     *           "Q" + FacilityID + "MSG", so we must either create
     *           a dummy message file or use a CPF message.
     *       In     Parms - Msgid of Error.
     *                      Severity.
     *                      User or System Error.
     *       In/Out Parms - None.
     *       Out    Parms - None.
     *     Return         - Condition Token.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p ERRH_BuildConditionToken...
     p                 b                   Export
     d                 pi                  Like(StdCndTok)
     d   InMessageId...
     d                                     Like(StdMsgId)
     d                                     Value
     d   InMessageSeverity...
     d                                     Like(StdIntSml)
     d                                     Value
     d   InConditionType...
     d                                     Like(StdChr)
     d                                     Value
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*
     * Prototype for ILE Signal Error Function.
     d ILE_SignalError...
     d                 pr                  ExtProc('CEESGL')
     d   PR_InConditionToken...
     d                                     Like(StdCndTok)
     d                                     Const

     d MessageId...
     d                 ds                  Qualified
     d   FacilityId...
     d                                3
     d   MessageNumber...
     d                                4s 0

     d cUpperAlpha...
     d                 c                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

     d MsgUXV0008...
     d                 ds                  Qualified
     d  ReasonCode...
     d                                     Like(StdIntSml)

     d Result...
     d                 s                   Like(StdInt)
     d ConditionToken...
     d                 s                   Like(StdCndTok)
      /Free

       //Validate parameters.
       If InMessageId = *Blanks;
         MsgUXV0008.ReasonCode = 1; // Must have a message Id.
         ERRH_AddMessage('UXV0008'         :
                         cXVMessageFileName:
                         MsgUXV0008        );
         INT_BuildConditionToken('CPF9899'         :
                                 99                :
                                 cConditionTypeUser:
                                 ConditionToken    );
         ILE_SignalError(ConditionToken);
       EndIf;

       If InMessageSeverity < 0 or InMessageSeverity > 99;
         MsgUXV0008.ReasonCode = 2; // Severity must be 0 to 99.
         ERRH_AddMessage('UXV0008'         :
                         cXVMessageFileName:
                         MsgUXV0008           );
         INT_BuildConditionToken('CPF9899'         :
                                 99                :
                                 cConditionTypeUser:
                                 ConditionToken    );
         ILE_SignalError(ConditionToken);
       EndIf;

       If InConditionType <> cConditionTypeUser and
          InConditionType <> cConditionTypeSystem;
         MsgUXV0008.ReasonCode = 3;  // Must be User or System Type Error.
         ERRH_AddMessage('UXV0008'         :
                         cXVMessageFileName:
                         MsgUXV0008           );
         INT_BuildConditionToken('CPF9899'         :
                                 99                :
                                 cConditionTypeUser:
                                 ConditionToken    );
         ILE_SignalError(ConditionToken);
       EndIf;

       MessageId = InMessageId;

       Result = %Check(cUpperAlpha         :
                       MessageId.FacilityID);
       If Result <> 0;
         MsgUXV0008.ReasonCode = 4; // Must be Upper Case Alpha only.
         ERRH_AddMessage('UXV0008'         :
                          cXVMessageFileName:
                          MsgUXV0008        );
         INT_BuildConditionToken('CPF9899'         :
                                 99                :
                                 cConditionTypeUser:
                                 ConditionToken    );
         ILE_SignalError(ConditionToken);
       EndIf;

       Monitor;
         Result = %Int(MessageID.MessageNumber);
       On-Error;
         MsgUXV0008.ReasonCode = 5;  //Must be all numeric.
         ERRH_AddMessage('UXV0008'         :
                         cXVMessageFileName:
                         MsgUXV0008        );
         INT_BuildConditionToken('CPF9899'         :
                                 99                :
                                 cConditionTypeUser:
                                 ConditionToken    );
         ILE_SignalError(ConditionToken);
       EndMon;

       If INT_BuildConditionToken(InMessageId      :
                                  InMessageSeverity:
                                  InConditionType  :
                                  ConditionToken   );
         MsgUXV0008.ReasonCode = 6;  //Build failed for unknown reason.
         ERRH_AddMessage('UXV0008'         :
                         cXVMessageFileName:
                         MsgUXV0008        );
         INT_BuildConditionToken('CPF9899'         :
                                 99                :
                                 cConditionTypeUser:
                                 ConditionToken    );
         ILE_SignalError(ConditionToken);
       EndIf;

       Return ConditionToken;

      /End-Free
     p                 e
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * INT_BuildConditionToken
     *   Build a condition token.
     *     In     Parms - Facility ID.
     *                    Message Number.
     *                    Severity.
     *                    Condition Type. User or System.
     *     In/Out Parms - None.
     *     Out    Parms - ConditionToken
     *   Return         - Error True or False
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p INT_BuildConditionToken...
     p                 b
     d                 pi                  Like(StdLgl)
     d   InMessageId...
     d                                     Like(StdMsgId)
     d                                     Value
     d   InSeverity...
     d                                     Like(StdIntSml)
     d                                     Value
     d   InConditionType...
     d                                     Like(StdChr)
     d                                     Value
     d   OutConditionToken...
     d                                     Like(StdCndTok)
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*
     * Prototype for ILE Construct Token Functions.
     d ILE_ConstructToken...
     d                 pr                  ExtProc('CEENCOD')
     d   PR_C1...
     d                                     Like(StdIntSml)
     d                                     Const
     d   PR_C2...
     d                                     Like(StdIntSml)
     d                                     Const
     d   PR_Case...
     d                                     Like(StdIntSml)
     d                                     Const
     d   PR_Severity...
     d                                     Like(StdIntSml)
     d                                     Const
     d   PR_Control...
     d                                     Like(StdIntSml)
     d                                     Const
     d   PR_FacilityId...
     d                                3    Const
     d   PR_ISInfo...
     d                                     Like(StdInt)
     d                                     Const
     d   PR_ReturnConditionToken...
     d                                     Like(StdCndTok)
     d   PR_FeedbackToken...
     d                                     Like(StdCndTok)
     d                                     Options(*Omit)
     d MessageId...
     d                 ds                  Qualified
     d   FacilityId...
     d                                3
     d   MessageNumber...
     d                                4s 0

     d C1...
     d                 s                   Like(StdIntSml)
     d C2...
     d                 s                   Like(StdIntSml)
     d Case...
     d                 s                   Like(StdIntSml)
     d                                     Inz(1)
     d ILESeverity...
     d                 s                   Like(StdIntSml)
     d Control...
     d                 s                   Like(StdIntSml)
     d FacilityId...
     d                 s              3
     d ISInfo...
     d                 s                   Like(StdInt)
     d                                     Inz(0)
     d ConditionToken...
     d                 s                   Like(StdCndTok)
     d                                     Inz(*Blanks)
     d FC...
     d                 s                   Like(StdCndTok)
     d                                     Inz(*Blanks)
      /Free

       OutConditionToken = *Blanks;

       MessageId = InMessageId;

       //Map the severity to ILE severity.
       Select;
         When InSeverity >= 0 and InSeverity <= 29;
           C1       = 2;
           ILESeverity = C1;
         When InSeverity >= 30 and InSeverity <= 39;
           C1       = 3;
           ILESeverity = C1;
         When InSeverity >= 40 and InSeverity <= 99;
           C1       = 4;
           ILESeverity = C1;
         EndSl;

       //Map condition type to value expected by CEENCOD.
       Select;
         When InConditionType = cConditionTypeUser;
           Control = 0;
         When InConditionType = cConditionTypeSystem;
           Control = 1;
       EndSl;

       C2         = MessageId.MessageNumber;
       FacilityId = MessageId.FacilityId;

       //Construct the token.
       Monitor;
         ILE_ConstructToken(C1               :
                            C2               :
                            Case             :
                            ILESeverity      :
                            Control          :
                            FacilityId       :
                            ISInfo           :
                            ConditionToken   :
                            FC               );
         If %Subst(FC:1:4) <> X'00000000';
           Return cTrue;
         EndIf;
       On-Error;
         Return cTrue;
       EndMon;

       OutConditionToken = ConditionToken;
       Return cFalse;

      /End-Free
     p                 e
